/* 
 * Much of this code was shamelessly ripped out of the oggvorbis 
 * "vorbisfile_example.c" program.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>
#include <ao/ao.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>

#define HOSTNAME "listen.fm4.amd.co.at"
#define PORT 31337
#define MAXSIZE 8192

#define BUF_SIZE 4096

int stop_flag = 0;

char pcmout[4096];		/* take 4k out of the data segment, not the stack */

OggVorbis_File vf;

#define INFO "Vorbis Module"

char *plugin_info(void)
{
    return INFO;
}

int input_plugin(void)
{
    return 1;
}

char* input_type(void)
{
    return "vorbis";
}

ao_device *device;

FILE *file;
int eof = 0;

void *play(void *);

int start(char *url)
{

    int s;
    struct hostent *he;
    struct sockaddr_in remote_addr;
    int n, c, last;


    char *buffer;
    int buf_size;
    int sample;
    float freq = 880.0;
    int i;
    char *t,*url_host,*url_port,*url_file;

    int default_driver;
    ao_sample_format format;
    pthread_t thread;

    url_port = url_host = url_file = 0;

    fprintf(stderr,"## %s ##\n",url);

    /* The following is most likely incredibly buggy, riddled with
     * buffer overruns and should not be used under any circumstances.
     * I just wanted it to work quickly. You have been warned. 
     */

    if (strncmp(url,"http://",7)) {
	    fprintf(stderr,"Not a url\n");
	    return 0;
    }

    t = index(url+7,':');

    if (!t) {
	    url_host = strdup(url+7);
	    url_port = strdup("80");
	    url_file = strdup("/");
    } else {
	    char *u;

	    url_host = (char *) malloc (sizeof(char) * (t-url-6));
	    strncpy(url_host,url+7,t-url-7);
	    url_host[t-url-7]=0;

	    u = index(t,'/');

	    if (!u) {
		    url_port=strdup(t+1);
		    url_file=strdup("/");
	    } else {
    	    	    fprintf(stderr,"C\n");
		    url_port = (char *) malloc (sizeof(char) * (u-t));
		    strncpy(url_port,t+1,u-t-1);
		    url_port[u-t-1]=0;

		    url_file = strdup(u);
	    }
    }

    fprintf(stderr,"Host: %s\n",url_host);
    fprintf(stderr,"Port: %s\n",url_port);
    fprintf(stderr,"File: %s\n",url_file);

    stop_flag = 0;

    s = socket(AF_INET, SOCK_STREAM, 0);


    he = gethostbyname(url_host);

    remote_addr.sin_family = AF_INET;
    remote_addr.sin_port = htons(atoi(url_port));
    remote_addr.sin_addr = *((struct in_addr *) he->h_addr);
    memset(&(remote_addr.sin_zero), '\0', 8);

    connect(s, (struct sockaddr *) &remote_addr, sizeof(struct sockaddr));

    send(s, "GET ", 4, 0);
    send(s, url_file, strlen(url_file), 0);
    send(s, " HTTP/1.0\r\n\r\n", 13, 0);

    file = fdopen(s, "r");


    while ((c = fgetc(file)) != EOF) {
	if (last == 10 && c == 13)
	    break;
	/*
	   if (c == 13) { printf("[CR]"); continue; }
	   printf("%c",c);
	   if (c == 10) printf("[LF]");
	 */
	last = c;
    }

    if (ov_open(file, &vf, NULL, 0) < 0) {
	fprintf(stderr, "Input does not appear to be an Ogg bitstream.\n");
	exit(1);
    }

    ao_initialize();
    default_driver = ao_default_driver_id();

    /* Throw the comments plus a few lines about the bitstream we're
       decoding */
    {
	char **ptr = ov_comment(&vf, -1)->user_comments;
	vorbis_info *vi = ov_info(&vf, -1);
	while (*ptr) {
	    fprintf(stderr, "%s\n", *ptr);
	    ++ptr;
	}
	fprintf(stderr, "\nBitstream is %d channel, %ldHz\n", vi->channels,
		vi->rate);
	fprintf(stderr, "\nDecoded length: %ld samples\n",
		(long) ov_pcm_total(&vf, -1));
	fprintf(stderr, "Encoded by: %s\n\n", ov_comment(&vf, -1)->vendor);
	format.bits = 16;	// XXX
	format.channels = vi->channels;
	format.rate = vi->rate;
	format.byte_format = AO_FMT_LITTLE;
    }

    device = ao_open_live(default_driver, &format, NULL /* no options */ );

    pthread_create(&thread,NULL,play,0);

/*
    signal(SIGALRM,play);
    alarm(1);
*/

    if (url_host) free(url_host);
    if (url_port) free(url_port);
    if (url_file) free(url_file);

    return 1;
}

void *play(void *threadid)
{
    int current_section;

    while(!stop_flag) {
	long ret =
	    ov_read(&vf, pcmout, sizeof(pcmout), 0, 2, 1,
		    &current_section);
	if (ret == 0) {
	    /* EOF */
	    eof = 1;
	} else if (ret < 0) {
	    /* error in the stream.  Not a problem, just reporting it in
	       case we (the app) cares.  In this case, we don't. */
	} else {
	    /* we don't bother dealing with sample rate changes, etc, but
	       you'll have to */
	    // fwrite(pcmout,1,ret,stdout);
	    ao_play(device, pcmout, ret);
	}
   }

    /* cleanup */
    ov_clear(&vf);
    ao_close(device);
    ao_shutdown();

    fprintf(stderr, "Done.\n");
    pthread_exit(NULL);
    return (0);
    
}

int stop(void)
{
	stop_flag = 1;
}

int status(void)
{
	return 7;		// INVALID
}

